Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# TextPropertiesManager Class Reference

This defines all of the TextProperties structures that might be referenced by name from an embedded text string. More...

List of all members.

## Public Member Functions
| clearGraphic (string name)
| Removes the named TextGraphic structure from the manager.
| clearProperties (string name)
| Removes the named TextProperties structure from the manager.
TextGraphic | getGraphic (string name)
| Returns the TextGraphic associated with the indicated name.
TextProperties | getProperties (string name)
| Returns the TextProperties associated with the indicated name.
bool | hasGraphic (string name)
| Returns true if a TextGraphic structure has been associated with the indicated name, false otherwise.
bool | hasProperties (string name)
| Returns true if a TextProperties structure has been associated with the indicated name, false otherwise.
| setGraphic (string name, NodePath const model)
| This flavor of set_graphic implicitly creates a frame for the model using the model's actual computed bounding volume, as derived from NodePath.calc_tight_bounds().
| setGraphic (string name, TextGraphic const graphic)
| Defines the TextGraphic associated with the indicated name.
| setProperties (string name, TextProperties const properties)
| Defines the TextProperties associated with the indicated name.
| write (ostream out)
| write (ostream out, int indent_level)
## Static Public Member Functions
static TextPropertiesManager | getGlobalPtr ()
| Returns the pointer to the global TextPropertiesManager object.

## Detailed Description

This defines all of the TextProperties structures that might be referenced by name from an embedded text string.

A text string, as rendered by a TextNode, can contain embedded references to one of the TextProperties defined here, by enclosing the name between \1 (ASCII 0x01) characters; this causes a "push" to the named state. All text following the closing \1 character will then be rendered in the new state. The next \2 (ASCII 0x02) character will then restore the previous state for subsequent text.

For instance, "x\1up\1n\2 + y" indicates that the character "x" will be rendered in the normal state, the character "n" will be rendered in the "up" state, and then " + y" will be rendered in the normal state again.

This can also be used to define arbitrary models that can serve as embedded graphic images in a text paragraph. This works similarly; the convention is to create a TextGraphic that describes the graphic image, and then associate it here via the set_graphic() call. Then "\5name\5" will embed the named graphic.

## Member Function Documentation

clearGraphic | ( | string | name | ) |

Removes the named TextGraphic structure from the manager.

clearProperties | ( | string | name | ) |

Removes the named TextProperties structure from the manager.

static TextPropertiesManager getGlobalPtr | ( |  | ) | `[static]`

Returns the pointer to the global TextPropertiesManager object.

TextGraphic getGraphic | ( | string | name | ) |

Returns the TextGraphic associated with the indicated name.

If there was not previously a TextGraphic associated with this name, a warning is printed and then a default TextGraphic structure is associated with the name, and returned.

Call has_graphic() instead to check whether a particular name has been defined.

TextProperties getProperties | ( | string | name | ) |

Returns the TextProperties associated with the indicated name.

If there was not previously a TextProperties associated with this name, a warning is printed and then a default TextProperties structure is associated with the name, and returned.

Call has_properties() instead to check whether a particular name has been defined.

bool hasGraphic | ( | string | name | ) |

Returns true if a TextGraphic structure has been associated with the indicated name, false otherwise.

Normally this means set_graphic() has been called with this name, but because get_graphic() will implicitly create a default TextGraphic structure, it may also mean simply that get_graphic() has been called with the indicated name.

bool hasProperties | ( | string | name | ) |

Returns true if a TextProperties structure has been associated with the indicated name, false otherwise.

Normally this means set_properties() has been called with this name, but because get_properties() will implicitly create a default TextProperties structure, it may also mean simply that get_properties() has been called with the indicated name.

setGraphic | ( | string | name,
|  | TextGraphic const | graphic
| ) |  |

Defines the TextGraphic associated with the indicated name.

When the name is subsequently encountered in text embedded between \5 characters in a TextNode string, the specified graphic will be embedded in the text at that point.

If there was already a TextGraphic structure associated with this name, it is quietly replaced with the new definition.

setGraphic | ( | string | name,
|  | NodePath const | model
| ) |  |

This flavor of set_graphic implicitly creates a frame for the model using the model's actual computed bounding volume, as derived from NodePath.calc_tight_bounds().

Create a TextGraphic object first if you want to have explicit control of the frame.

setProperties | ( | string | name,
|  | TextProperties const | properties
| ) |  |

Defines the TextProperties associated with the indicated name.

When the name is subsequently encountered in text embedded between \1 characters in a TextNode string, the following text will be rendered with these properties.

If there was already a TextProperties structure associated with this name, it is quietly replaced with the new definition.

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

write | ( | ostream | out | ) |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties